# openapi-java-client

Chat API SDK
- API version: 1.0.0
  - Build date: 2019-10-24T15:11:21.199Z[GMT]

The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.


*Automatically generated by the [OpenAPI Generator](https://openapi-generator.tech)*


## Requirements

Building the API client library requires:
1. Java 1.7+
2. Maven/Gradle

## Installation

To install the API client library to your local Maven repository, simply execute:

```shell
mvn clean install
```

To deploy it to a remote Maven repository instead, configure the settings of the repository and execute:

```shell
mvn clean deploy
```

Refer to the [OSSRH Guide](http://central.sonatype.org/pages/ossrh-guide.html) for more information.

### Maven users

Add this dependency to your project's POM:

```xml
<dependency>
  <groupId>org.openapitools</groupId>
  <artifactId>openapi-java-client</artifactId>
  <version>1.0.0</version>
  <scope>compile</scope>
</dependency>
```

### Gradle users

Add this dependency to your project's build file:

```groovy
compile "org.openapitools:openapi-java-client:1.0.0"
```

### Others

At first generate the JAR by executing:

```shell
mvn clean package
```

Then manually install the following JARs:

* `target/openapi-java-client-1.0.0.jar`
* `target/lib/*.jar`

## Getting Started

Please follow the [installation](#installation) instruction and execute the following Java code:

```java

// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.auth.*;
import org.openapitools.client.models.*;
import org.openapitools.client.api.Class1InstanceApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api.chat-api.com");
    
    // Configure API key authorization: instanceId
    ApiKeyAuth instanceId = (ApiKeyAuth) defaultClient.getAuthentication("instanceId");
    instanceId.setApiKey("YOUR API KEY");
    // Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
    //instanceId.setApiKeyPrefix("Token");

    // Configure API key authorization: token
    ApiKeyAuth token = (ApiKeyAuth) defaultClient.getAuthentication("token");
    token.setApiKey("YOUR API KEY");
    // Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
    //token.setApiKeyPrefix("Token");

    Class1InstanceApi apiInstance = new Class1InstanceApi(defaultClient);
    try {
      InlineResponse2002 result = apiInstance.expiry();
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling Class1InstanceApi#expiry");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

```

## Documentation for API Endpoints

All URIs are relative to *https://api.chat-api.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*Class1InstanceApi* | [**expiry**](docs/Class1InstanceApi.md#expiry) | **POST** /expiry | Updates the QR code after its expired
*Class1InstanceApi* | [**getQRCode**](docs/Class1InstanceApi.md#getQRCode) | **GET** /qr_code | Direct link to QR-code in the form of an image, not base64.
*Class1InstanceApi* | [**getSettings**](docs/Class1InstanceApi.md#getSettings) | **GET** /settings | Get settings
*Class1InstanceApi* | [**getStatus**](docs/Class1InstanceApi.md#getStatus) | **GET** /status | Get the account status and QR code for authorization.
*Class1InstanceApi* | [**logout**](docs/Class1InstanceApi.md#logout) | **POST** /logout | Logout from WhatsApp Web to get new QR code.
*Class1InstanceApi* | [**reboot**](docs/Class1InstanceApi.md#reboot) | **POST** /reboot | Reboot your whatsapp instance.
*Class1InstanceApi* | [**retry**](docs/Class1InstanceApi.md#retry) | **POST** /retry | Repeat the manual synchronization attempt with the device
*Class1InstanceApi* | [**setSettings**](docs/Class1InstanceApi.md#setSettings) | **POST** /settings | Set settings
*Class1InstanceApi* | [**takeover**](docs/Class1InstanceApi.md#takeover) | **POST** /takeover | Returns the active session if the device has connected another instance of Web WhatsApp
*Class2MessagesApi* | [**forwardMessage**](docs/Class2MessagesApi.md#forwardMessage) | **POST** /forwardMessage | Forwarding messages to a new or existing chat.
*Class2MessagesApi* | [**getMessages**](docs/Class2MessagesApi.md#getMessages) | **GET** /messages | Get a list of messages.
*Class2MessagesApi* | [**sendContact**](docs/Class2MessagesApi.md#sendContact) | **POST** /sendContact | Sending a contact or contact list to a new or existing chat.
*Class2MessagesApi* | [**sendFile**](docs/Class2MessagesApi.md#sendFile) | **POST** /sendFile | Send a file to a new or existing chat.
*Class2MessagesApi* | [**sendLink**](docs/Class2MessagesApi.md#sendLink) | **POST** /sendLink | Send text with link and link&#39;s preview to a new or existing chat.
*Class2MessagesApi* | [**sendLocation**](docs/Class2MessagesApi.md#sendLocation) | **POST** /sendLocation | Sending a location to a new or existing chat.
*Class2MessagesApi* | [**sendMessage**](docs/Class2MessagesApi.md#sendMessage) | **POST** /sendMessage | Send a message to a new or existing chat.
*Class2MessagesApi* | [**sendPTT**](docs/Class2MessagesApi.md#sendPTT) | **POST** /sendPTT | Send a ptt-audio to a new or existing chat.
*Class2MessagesApi* | [**sendVCard**](docs/Class2MessagesApi.md#sendVCard) | **POST** /sendVCard | Sending a vcard to a new or existing chat.
*Class3ChatsApi* | [**addGroupParticipant**](docs/Class3ChatsApi.md#addGroupParticipant) | **POST** /addGroupParticipant | Adding participant to a group
*Class3ChatsApi* | [**demoteGroupParticipant**](docs/Class3ChatsApi.md#demoteGroupParticipant) | **POST** /demoteGroupParticipant | Demote group participant
*Class3ChatsApi* | [**getChats**](docs/Class3ChatsApi.md#getChats) | **GET** /dialogs | Get the chat list.
*Class3ChatsApi* | [**group**](docs/Class3ChatsApi.md#group) | **POST** /group | Creates a group and sends the message to the created group.
*Class3ChatsApi* | [**promoteGroupParticipant**](docs/Class3ChatsApi.md#promoteGroupParticipant) | **POST** /promoteGroupParticipant | Make participant in the group an administrator
*Class3ChatsApi* | [**readChat**](docs/Class3ChatsApi.md#readChat) | **POST** /readChat | Open chat for reading messages
*Class3ChatsApi* | [**removeGroupParticipant**](docs/Class3ChatsApi.md#removeGroupParticipant) | **POST** /removeGroupParticipant | Remove participant from a group
*Class4WebhooksApi* | [**setWebhook**](docs/Class4WebhooksApi.md#setWebhook) | **POST** /webhook | Sets the URL for receiving webhook
*Class5QueuesApi* | [**clearActionsQueue**](docs/Class5QueuesApi.md#clearActionsQueue) | **POST** /clearActionsQueue | Clear outbound actions queue.
*Class5QueuesApi* | [**clearMessagesQueue**](docs/Class5QueuesApi.md#clearMessagesQueue) | **POST** /clearMessagesQueue | Clear outbound messages queue.
*Class5QueuesApi* | [**showActionsQueue**](docs/Class5QueuesApi.md#showActionsQueue) | **GET** /showActionsQueue | Get outbound messages queue.
*Class5QueuesApi* | [**showMessagesQueue**](docs/Class5QueuesApi.md#showMessagesQueue) | **GET** /showMessagesQueue | Get outbound messages queue.
*Class6BanApi* | [**banTest**](docs/Class6BanApi.md#banTest) | **POST** /banTest | Test ban settings
*Class6BanApi* | [**getBanSettings**](docs/Class6BanApi.md#getBanSettings) | **GET** /banSettings | Get settings
*Class6BanApi* | [**setBanSettings**](docs/Class6BanApi.md#setBanSettings) | **POST** /banSettings | Set settings
*Class7TestingApi* | [**instanceStatuses**](docs/Class7TestingApi.md#instanceStatuses) | **GET** /instanceStatuses | Returns instance status changes history.
*Class7TestingApi* | [**webhookStatuses**](docs/Class7TestingApi.md#webhookStatuses) | **GET** /webhookStatus | Returns webhook status for message.


## Documentation for Models

 - [Ack](docs/Ack.md)
 - [BanSettings](docs/BanSettings.md)
 - [BanTestAction](docs/BanTestAction.md)
 - [BanTestStatus](docs/BanTestStatus.md)
 - [Chat](docs/Chat.md)
 - [ChatIdProp](docs/ChatIdProp.md)
 - [ChatUpdate](docs/ChatUpdate.md)
 - [Chats](docs/Chats.md)
 - [ClearActionsQueueStatus](docs/ClearActionsQueueStatus.md)
 - [ClearMessagesQueueStatus](docs/ClearMessagesQueueStatus.md)
 - [CreateGroupAction](docs/CreateGroupAction.md)
 - [CreateGroupStatus](docs/CreateGroupStatus.md)
 - [ForwardMessageRequest](docs/ForwardMessageRequest.md)
 - [GroupParticipantAction](docs/GroupParticipantAction.md)
 - [GroupParticipantStatus](docs/GroupParticipantStatus.md)
 - [InlineResponse200](docs/InlineResponse200.md)
 - [InlineResponse2001](docs/InlineResponse2001.md)
 - [InlineResponse2002](docs/InlineResponse2002.md)
 - [InlineResponse2003](docs/InlineResponse2003.md)
 - [InlineResponse2004](docs/InlineResponse2004.md)
 - [InlineResponse2005](docs/InlineResponse2005.md)
 - [InlineResponse2005Update](docs/InlineResponse2005Update.md)
 - [InlineResponse401](docs/InlineResponse401.md)
 - [InstanceStatus](docs/InstanceStatus.md)
 - [InstanceStatusAction](docs/InstanceStatusAction.md)
 - [InstanceStatusLink](docs/InstanceStatusLink.md)
 - [InstanceStatusStatusData](docs/InstanceStatusStatusData.md)
 - [InstanceStatusStatusDataActions](docs/InstanceStatusStatusDataActions.md)
 - [Message](docs/Message.md)
 - [Messages](docs/Messages.md)
 - [OutboundAction](docs/OutboundAction.md)
 - [OutboundActions](docs/OutboundActions.md)
 - [OutboundMessage](docs/OutboundMessage.md)
 - [OutboundMessages](docs/OutboundMessages.md)
 - [PhoneProp](docs/PhoneProp.md)
 - [ReadChatAction](docs/ReadChatAction.md)
 - [ReadChatStatus](docs/ReadChatStatus.md)
 - [SendContactRequest](docs/SendContactRequest.md)
 - [SendFileRequest](docs/SendFileRequest.md)
 - [SendLinkRequest](docs/SendLinkRequest.md)
 - [SendLocationRequest](docs/SendLocationRequest.md)
 - [SendMessageRequest](docs/SendMessageRequest.md)
 - [SendMessageStatus](docs/SendMessageStatus.md)
 - [SendPTTRequest](docs/SendPTTRequest.md)
 - [SendVCardRequest](docs/SendVCardRequest.md)
 - [SetWebhookStatus](docs/SetWebhookStatus.md)
 - [Settings](docs/Settings.md)
 - [Status](docs/Status.md)
 - [Statuses](docs/Statuses.md)
 - [WebhookStatus](docs/WebhookStatus.md)
 - [WebhookUrl](docs/WebhookUrl.md)


## Documentation for Authorization

Authentication schemes defined for the API:
### instanceId

- **Type**: API key
- **API key parameter name**: instanceId
- **Location**: URL query string

### token

- **Type**: API key
- **API key parameter name**: token
- **Location**: URL query string


## Recommendation

It's recommended to create an instance of `ApiClient` per thread in a multithreaded environment to avoid any potential issues.

## Author

sale@chat-api.com

