/*
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Ack
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2019-10-24T15:11:21.199Z[GMT]")
public class Ack {
  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private String id;

  public static final String SERIALIZED_NAME_QUEUE_NUMBER = "queueNumber";
  @SerializedName(SERIALIZED_NAME_QUEUE_NUMBER)
  private Integer queueNumber;

  public static final String SERIALIZED_NAME_CHAT_ID = "chatId";
  @SerializedName(SERIALIZED_NAME_CHAT_ID)
  private String chatId;

  /**
   * type of the message status
   */
  @JsonAdapter(StatusEnum.Adapter.class)
  public enum StatusEnum {
    DELIVERED("delivered"),
    
    VIEWED("viewed");

    private String value;

    StatusEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static StatusEnum fromValue(String value) {
      for (StatusEnum b : StatusEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<StatusEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final StatusEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public StatusEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return StatusEnum.fromValue(value);
      }
    }
  }

  public static final String SERIALIZED_NAME_STATUS = "status";
  @SerializedName(SERIALIZED_NAME_STATUS)
  private StatusEnum status;


  public Ack id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * unique id
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "false_17472822486@c.us_DF38E6A25B42CC8CCE57EC40F", value = "unique id")

  public String getId() {
    return id;
  }



  public void setId(String id) {
    this.id = id;
  }


  public Ack queueNumber(Integer queueNumber) {
    
    this.queueNumber = queueNumber;
    return this;
  }

   /**
   * message id in queue
   * @return queueNumber
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "100", value = "message id in queue")

  public Integer getQueueNumber() {
    return queueNumber;
  }



  public void setQueueNumber(Integer queueNumber) {
    this.queueNumber = queueNumber;
  }


  public Ack chatId(String chatId) {
    
    this.chatId = chatId;
    return this;
  }

   /**
   * chat ID
   * @return chatId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "17472822486@c.us", value = "chat ID")

  public String getChatId() {
    return chatId;
  }



  public void setChatId(String chatId) {
    this.chatId = chatId;
  }


  public Ack status(StatusEnum status) {
    
    this.status = status;
    return this;
  }

   /**
   * type of the message status
   * @return status
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "viewed", value = "type of the message status")

  public StatusEnum getStatus() {
    return status;
  }



  public void setStatus(StatusEnum status) {
    this.status = status;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Ack ack = (Ack) o;
    return Objects.equals(this.id, ack.id) &&
        Objects.equals(this.queueNumber, ack.queueNumber) &&
        Objects.equals(this.chatId, ack.chatId) &&
        Objects.equals(this.status, ack.status);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, queueNumber, chatId, status);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Ack {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    queueNumber: ").append(toIndentedString(queueNumber)).append("\n");
    sb.append("    chatId: ").append(toIndentedString(chatId)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

