/*
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * Chat
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2019-10-24T15:11:21.199Z[GMT]")
public class Chat {
  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private String id;

  public static final String SERIALIZED_NAME_NAME = "name";
  @SerializedName(SERIALIZED_NAME_NAME)
  private String name;

  public static final String SERIALIZED_NAME_IMAGE = "image";
  @SerializedName(SERIALIZED_NAME_IMAGE)
  private String image;

  public static final String SERIALIZED_NAME_METADATA = "metadata";
  @SerializedName(SERIALIZED_NAME_METADATA)
  private Object metadata;


  public Chat id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * chat id
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1493046918@g.us-13216468942@c.us", value = "chat id")

  public String getId() {
    return id;
  }



  public void setId(String id) {
    this.id = id;
  }


  public Chat name(String name) {
    
    this.name = name;
    return this;
  }

   /**
   * chat name
   * @return name
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "Ok!", value = "chat name")

  public String getName() {
    return name;
  }



  public void setName(String name) {
    this.name = name;
  }


  public Chat image(String image) {
    
    this.image = image;
    return this;
  }

   /**
   * HTTPS link on avatar or group image
   * @return image
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "https://pps.whatsapp.net/v/t61.11540-24/42886681_356710581739497_4892819781461213184_n.jpg?oe=5BD90F82&oh=c256f7e5c7aeccd19cf2e626f3ef4236", value = "HTTPS link on avatar or group image")

  public String getImage() {
    return image;
  }



  public void setImage(String image) {
    this.image = image;
  }


  public Chat metadata(Object metadata) {
    
    this.metadata = metadata;
    return this;
  }

   /**
   * Additional info about chat
   * @return metadata
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "Additional info about chat")

  public Object getMetadata() {
    return metadata;
  }



  public void setMetadata(Object metadata) {
    this.metadata = metadata;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Chat chat = (Chat) o;
    return Objects.equals(this.id, chat.id) &&
        Objects.equals(this.name, chat.name) &&
        Objects.equals(this.image, chat.image) &&
        Objects.equals(this.metadata, chat.metadata);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, image, metadata);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Chat {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    image: ").append(toIndentedString(image)).append("\n");
    sb.append("    metadata: ").append(toIndentedString(metadata)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

