/*
 * Chat API SDK
 * The SDK allows you to receive and send messages through your WhatsApp account. [Sign up now](https://app.chat-api.com/)  The Chat API is based on the WhatsApp WEB protocol and excludes the ban both when using libraries from mgp25 and the like. Despite this, your account can be banned by anti-spam system WhatsApp after several clicking the \"block\" button.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: sale@chat-api.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * OutboundAction
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2019-10-24T15:11:21.199Z[GMT]")
public class OutboundAction {
  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private Integer id;

  /**
   * type of the action in queue
   */
  @JsonAdapter(TypeEnum.Adapter.class)
  public enum TypeEnum {
    CREATE_GROUP("create group"),
    
    ADD_GROUP_PARTICIPANT("add group participant"),
    
    REMOVE_GROUP_PARTICIPANT("remove group participant"),
    
    PROMOTE_GROUP_PARTICIPANT("promote group participant"),
    
    DEMOTE_GROUP_PARTICIPANT("demote group participant"),
    
    READ_CHAT("read chat");

    private String value;

    TypeEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static TypeEnum fromValue(String value) {
      for (TypeEnum b : TypeEnum.values()) {
        if (b.value.equals(value)) {
          return b;
        }
      }
      throw new IllegalArgumentException("Unexpected value '" + value + "'");
    }

    public static class Adapter extends TypeAdapter<TypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final TypeEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public TypeEnum read(final JsonReader jsonReader) throws IOException {
        String value =  jsonReader.nextString();
        return TypeEnum.fromValue(value);
      }
    }
  }

  public static final String SERIALIZED_NAME_TYPE = "type";
  @SerializedName(SERIALIZED_NAME_TYPE)
  private TypeEnum type;

  public static final String SERIALIZED_NAME_LAST_TRY = "last_try";
  @SerializedName(SERIALIZED_NAME_LAST_TRY)
  private Integer lastTry;

  public static final String SERIALIZED_NAME_JSON_DATA = "json_data";
  @SerializedName(SERIALIZED_NAME_JSON_DATA)
  private Object jsonData;


  public OutboundAction id(Integer id) {
    
    this.id = id;
    return this;
  }

   /**
   * action id in queue
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1", value = "action id in queue")

  public Integer getId() {
    return id;
  }



  public void setId(Integer id) {
    this.id = id;
  }


  public OutboundAction type(TypeEnum type) {
    
    this.type = type;
    return this;
  }

   /**
   * type of the action in queue
   * @return type
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "chat", value = "type of the action in queue")

  public TypeEnum getType() {
    return type;
  }



  public void setType(TypeEnum type) {
    this.type = type;
  }


  public OutboundAction lastTry(Integer lastTry) {
    
    this.lastTry = lastTry;
    return this;
  }

   /**
   * Last try time to execute a action
   * @return lastTry
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1528320463", value = "Last try time to execute a action")

  public Integer getLastTry() {
    return lastTry;
  }



  public void setLastTry(Integer lastTry) {
    this.lastTry = lastTry;
  }


  public OutboundAction jsonData(Object jsonData) {
    
    this.jsonData = jsonData;
    return this;
  }

   /**
   * Additional action data
   * @return jsonData
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "{}", value = "Additional action data")

  public Object getJsonData() {
    return jsonData;
  }



  public void setJsonData(Object jsonData) {
    this.jsonData = jsonData;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    OutboundAction outboundAction = (OutboundAction) o;
    return Objects.equals(this.id, outboundAction.id) &&
        Objects.equals(this.type, outboundAction.type) &&
        Objects.equals(this.lastTry, outboundAction.lastTry) &&
        Objects.equals(this.jsonData, outboundAction.jsonData);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, type, lastTry, jsonData);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class OutboundAction {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    lastTry: ").append(toIndentedString(lastTry)).append("\n");
    sb.append("    jsonData: ").append(toIndentedString(jsonData)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

